
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_width1  2
#property indicator_color2 Red
#property indicator_width2  2
#property indicator_color3 White
#property indicator_width3  2


input int period=2; // Close of a bar how many periods back
input bool updateeverytick=false;
input bool alert=true;

double diff[], up[], dn[];

int timeoffirstbar, limitdown=1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
    
//---- indicator line
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,up);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dn);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,diff);
  
   timeoffirstbar=Time[1];
   if (updateeverytick) limitdown=0;   
      
   IndicatorShortName("Trend Balance Point");
   return(0);
  }

//----


 
//+------------------------------------------------------------------+
//| MTF Supertrend                                                   |
//+------------------------------------------------------------------+

int start()
  {

   int    i, limit, counted_bars=IndicatorCounted(); 
   

// Plot defined time frame on to current time frame

   

   limit=Bars-counted_bars;
   for(i=limit;i>=limitdown;i--)
   {
    diff[i]=Close[i]-Close[i+period];       
    if (diff[i]>0.0) {up[i]=diff[i]; dn[i]=0.0;};
    if (diff[i]<0.0) {dn[i]=diff[i]; up[i]=0.0;};   
   }   
   
   // alert, if it hasn't been called already for the closed bar, and if the differential is sufficiently large:
   if ((alert) && (Time[1]!=timeoffirstbar) && (diff[1] > diff[2] && diff[1] > diff[3])) 
      {
      Alert("Trend Balance Point BUY"+Symbol());
      PlaySound("TBPB.wav");  
      timeoffirstbar=Time[1];
      }      
   if ((alert) && (Time[1]!=timeoffirstbar) && (-diff[1] < diff[2]  && -diff[1] < diff[3] )) 
      {
      Alert("Trend Balance Point SELL"+Symbol());
      PlaySound("TBPS.wav");
      timeoffirstbar=Time[1];
      }    
   
   return(0);
  }
//+------------------------------------------------------------------+


